/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package KDDCup05;

import KDDCup05.LoadLabeler.ScoringFormula;
import com.google.gson.JsonArray;
import com.google.gson.JsonParser;
import finals.Finals;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import lemur.dataStructures.CategoryScoreRank;
import static lemur.queryIndexTesting.loadCategoriesFromCSV;
import lemurproject.indri.QueryEnvironment;
import lemurproject.indri.ScoredExtentResult;
import org.supercsv.cellprocessor.Optional;
import org.supercsv.cellprocessor.ParseInt;
import org.supercsv.cellprocessor.constraint.NotNull;
import org.supercsv.cellprocessor.ift.CellProcessor;
import org.supercsv.io.CsvListReader;
import org.supercsv.io.ICsvListReader;
import org.supercsv.prefs.CsvPreference;
import scheduler.CategorizerExecutionRunnable;
import sqlite.CategoryDataSource;
import sqlite.dataSources.Categorization;
import sqlite.dataSources.Category;
import sqlite.dataSources.Search;

/**
 *
 * @author drosatosgr
 */
public class Testing {

    static int topNCateg = 5;
    static int totalResults = 3;
    static String pathLabelers = "files/kddcup05/labeler"+"*"+".txt";
    static int numLabelers = 3;
    static String index = "files/kddcup05_v3/";
    static String indexStats = "files/www-1-20000-seed1/";
    static String csv = "files/KDD_Categories_v3.csv";
    static ScoringFormula sF = ScoringFormula.ApplyClassificationWithWeightVoteMulticlassificationKNN;
    static boolean excludeUnclassifiedQueries = false;
    
    // -- kddcup05_v2, Base = 2.0, excludeUnclassifiedQueries = false
    //Total Precision: 0.2019187256765318
    //Total Recall: 0.2902209874895443
    //Total F1: 0.23553614745363222

    //-- kddcup05_v2, Base = Math.E, ApplyClassificationWithExponentOfScores, excludeUnclassifiedQueries = false
    //Total Precision: 0.2076205991492443
    //Total Recall: 0.29831681868287524
    //Total F1: 0.24215337961775713
 
    //-- kddcup05_v3, Base = Math.E, ApplyClassificationWithExponentOfScores, excludeUnclassifiedQueries = false
    //Total Precision: 0.20711183496199784
    //Total Recall: 0.2976386067329834
    //Total F1: 0.24157873074326708

    //-- kddcup05_v3, Base = Math.E, ApplyClassificationWithCombinedPosibilities, excludeUnclassifiedQueries = false
    //Total Precision: 0.12024972855591748
    //Total Recall: 0.17266205642013777
    //Total F1: 0.14021749456678576  
    
    //-- kddcup05_v3, Base = Math.E, ApplyClassificationWithNormalizedCombinedPosibilities, excludeUnclassifiedQueries = false
    //Total Precision: 0.19996380745566414
    //Total Recall: 0.28549198286323335
    //Total F1: 0.23266130666142287

    public static void main(String[] args) {
        Hashtable<Integer, Category> categs = loadCategoriesFromCSV(csv);
        
        LoadLabeler classified = new LoadLabeler();
        HashSet<String> unclassifiedQueries = classified.classifyQuerySet(index, totalResults, topNCateg, LoadLabeler.getOnlyQueries(pathLabelers.replace("*", "1")), categs, sF, excludeUnclassifiedQueries);
        //classified.printUniqueCategories();
        System.out.println("Classified is correct: "+classified.validate(categs)+"\n- Classified Queries: "+(excludeUnclassifiedQueries ? (classified.categoriesPerQuery.size()+"/"+(classified.categoriesPerQuery.size()+unclassifiedQueries.size())) : ((classified.categoriesPerQuery.size()-unclassifiedQueries.size())+"/"+classified.categoriesPerQuery.size()))+"\n- Sum of Queries per Category: "+classified.sumOfQueriesPerCategory());
        //classified.printAll();       
        
        LoadLabeler[] labeler = new LoadLabeler[numLabelers];
        for(int i=0;i<labeler.length;i++){
            labeler[i] = new LoadLabeler();
            if(excludeUnclassifiedQueries){
                labeler[i].load(pathLabelers.replace("*", ""+(i+1)), unclassifiedQueries);
            }else{
                labeler[i].load(pathLabelers.replace("*", ""+(i+1)), new HashSet<String>());
            }
            //labeler[i].printUniqueCategories();
            System.out.println("Labeler"+(i+1)+" is correct: "+labeler[i].validate(categs)+"\n- Queries: "+labeler[i].categoriesPerQuery.size()+"\n- Sum of Queries per Category: "+labeler[i].sumOfQueriesPerCategory());
            //labeler[i].printAll();
        }
                
        double totalPrecision = 0.0;
        double totalRecall = 0.0;
        double totalF1 = 0.0;
        
        for(int i=0;i<labeler.length;i++){
            int a = labeler[i].sumOfQueriesPerCorrectlyTaggedCategory(classified);
            int b = classified.sumOfQueriesPerCategory();
            int c = labeler[i].sumOfQueriesPerCategory();
            double precision = (double) a / (double) b;
            totalPrecision += precision / (double)labeler.length;
            double recall = (double) a / (double) c;
            totalRecall += recall / (double)labeler.length;
            double f1 = (2.0 * precision * recall) / (precision + recall);
            totalF1 += f1 / (double)labeler.length;
            
            
            System.out.println("-- Labeler"+(i+1)+": ");
            System.out.println("- Precision: "+precision);
            System.out.println("- Recall: "+recall);
            System.out.println("- F1: "+f1);
        }
        System.out.println("--------------------------------------");
        System.out.println("Total Precision: " + totalPrecision);
        System.out.println("Total Recall: " + totalRecall);
        System.out.println("Total F1: " + totalF1);
    }

    public static Hashtable<Integer, Category> loadCategoriesFromCSV(String file) {
        Hashtable<Integer, Category> categ = new Hashtable<Integer, Category>();
        try {
            //CsvPreference SPACE_DELIMITED = new CsvPreference.Builder('"', ' ', "\r\n").build();
            CsvPreference STANDARD_PREFERENCE = new CsvPreference.Builder('"', ';', "\r\n").build();
            ICsvListReader inFile = new CsvListReader(new FileReader(file), STANDARD_PREFERENCE /*CsvPreference.STANDARD_PREFERENCE*/);
            final CellProcessor[] processors = new CellProcessor[]{
                new NotNull(new ParseInt()), //_id
                new NotNull(), // name
                new Optional(), // description
                new Optional(new ParseInt()), //parent_id
                new Optional(new ParseInt()), //forUploading
            };

            String[] header = inFile.getHeader(true);
            List<Object> customerList;
            while ((customerList = inFile.read(processors)) != null) {

                Integer _id = (Integer) customerList.get(0);
                String name = (String) customerList.get(1);
                String desc = (String) customerList.get(2);
                Integer parent_id = (Integer) customerList.get(3);
                Integer forUploading = (Integer) customerList.get(4);

                //if (parent_id != null) {
                categ.put(_id, new Category(_id, name, desc, parent_id, forUploading));
                //}
            }

            inFile.close();

        } catch (FileNotFoundException ex) {
            Logger.getLogger(Testing.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Testing.class.getName()).log(Level.SEVERE, null, ex);
        }
        return categ;
    }
}
