/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package finals;

import java.awt.Image;
import java.awt.TrayIcon;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.Properties;
import java.util.UUID;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import mainPackage.TrayIconCarre;
import tools.Files;

/**
 *
 * @author drosatosgr
 */
public class Finals {

    public static TrayIcon trayIcon = null;
    
    public final static String appName = "CARRE Lifestyle Aggregator";
    public final static String appSubName = "User Intention Extractor";
    public final static String appVersion = "v1.3";
    public final static String appReleaseDate = "02 May 2015";
    public final static String appDeveloper = "George Drosatos";
    public final static String appEmail = "gdrosato@ee.duth.gr";
    public final static String appLogo = "/mainPackage/images/CARRE-Logo.png";
    public final static String seed = "Kalws Hr8ate sto CARRE";
    public static String appUUID = "";
    public static boolean stWithWindows = true;
    
    public static Image putIconImage() {
        URL imageURL = TrayIconCarre.class.getResource(appLogo);
        if (imageURL == null) {
            System.err.println("Resource not found: " + appLogo);
            return null;
        } else {
            return (new ImageIcon(imageURL)).getImage();
        }
    }

    public final static String fSep = System.getProperty("file.separator");
    public final static String appFolder = "CARRELifestyleAggregator";
    public final static String homeDir = System.getProperty("user.home") + fSep + appFolder + fSep;
    public final static String dbFolder = homeDir + "database" + fSep;
    public final static String dbName = "carre_lifestyle_data.db";
    public final static String dbURL = dbFolder + dbName;
    public final static String logsFolder = homeDir + "logs" + fSep;
    public final static String logs = logsFolder +"LogOf" + Finals.appFolder + ".log";

    public final static String filesFolder = "files";
    public static String categoriesCSV = filesFolder + fSep + "www.similarweb.com_Categories_v4.csv";
    public static String indexForCategorizer = filesFolder + fSep + "similarweb_v4" + fSep;
    
    public static int webServerListenerPort = 8000;
    public final static String webServerListenerHost = "127.0.0.1";
    public final static String webServerPathAPI = "/api";
    
    public final static int threadsOnScheduler = 3; // 1: WebServer, 2: Categorizer & 3: Uploader
    public static long checkingPeriodOfCategorizer = 60; //sec
    public static long checkingPeriodOfRDFSender = 60; //sec
    
    public final static int retrievalCutOff = 100000;
    public final static int topNCategories = 3;
    public static enum Method { AVGLMScore, ExponentLMScore }
    public final static Method kNNscoring = Method.ExponentLMScore;

    public static String urlSignUp = "https://carre.kmi.open.ac.uk/devices/accounts/register";
    public static String urlPrivateRDF = "https://carre.kmi.open.ac.uk/sparql-auth"; //"http://carre.kmi.open.ac.uk:8890/sparql-auth";
    public static String userCARRE = "rA6eFK9v90MCBYXOK97rig==";
    public static String passCARRE = "rA6eFK9v90MCBYXOK97rig==";
    public static String urlPrivateIRI = "https://carre.kmi.open.ac.uk/users/";
    public static String urlOWL = "http://carre.kmi.open.ac.uk/ontology/lifestyle.owl";

    public final static String configFile = homeDir + "config.xml";
    public static Properties configProps = new Properties();
    public final static String cssGraph = filesFolder + fSep + "graph.css";

    public static void loadProperties() {
        InputStream inputStream = null;
        try {
            // loads properties from file
            if(Files.existsFile(configFile)){
                inputStream = new FileInputStream(configFile);
                configProps.loadFromXML(inputStream);
            }
            appUUID = configProps.getProperty("appUUID", UUID.randomUUID().toString());
            categoriesCSV = configProps.getProperty("categoriesCSV", categoriesCSV);
            indexForCategorizer = configProps.getProperty("indexForCategorizer", indexForCategorizer);
            webServerListenerPort = Integer.valueOf(configProps.getProperty("webServerListenerPort", ""+webServerListenerPort));
            checkingPeriodOfCategorizer = Long.valueOf(configProps.getProperty("checkingPeriodOfCategorizer", ""+checkingPeriodOfCategorizer));
            checkingPeriodOfRDFSender = Long.valueOf(configProps.getProperty("checkingPeriodOfRDFSender", ""+checkingPeriodOfRDFSender));
            urlSignUp = configProps.getProperty("urlSignUp", urlSignUp);
            urlPrivateRDF = configProps.getProperty("urlPrivateRDF", urlPrivateRDF);
            urlPrivateIRI = configProps.getProperty("urlPrivateIRI", urlPrivateIRI);
            urlOWL = configProps.getProperty("urlOWL", urlOWL);
            userCARRE = configProps.getProperty("userCARRE", userCARRE);
            passCARRE = configProps.getProperty("passCARRE", passCARRE);
            stWithWindows = Boolean.valueOf(configProps.getProperty("stWithWindows", ""+stWithWindows));
            if(inputStream != null) inputStream.close();
            Logger.getLogger(Finals.class.getName()).log(Level.INFO, "Properties are loaded.");
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                if(inputStream != null) inputStream.close();
            } catch (IOException ex) {
                Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public static void saveProperties() {
        OutputStream outputStream = null;
        try {
            configProps.setProperty("appUUID", appUUID);
            configProps.setProperty("categoriesCSV", categoriesCSV);
            configProps.setProperty("indexForCategorizer", indexForCategorizer);
            configProps.setProperty("webServerListenerPort", "" + webServerListenerPort);
            configProps.setProperty("checkingPeriodOfCategorizer", "" + checkingPeriodOfCategorizer);
            configProps.setProperty("checkingPeriodOfRDFSender", "" + checkingPeriodOfRDFSender);
            configProps.setProperty("urlSignUp",urlSignUp);
            configProps.setProperty("urlPrivateRDF", urlPrivateRDF);
            configProps.setProperty("urlPrivateIRI", urlPrivateIRI);
            configProps.setProperty("urlOWL", urlOWL);
            configProps.setProperty("userCARRE", userCARRE);
            configProps.setProperty("passCARRE", passCARRE);
            configProps.setProperty("stWithWindows", ""+stWithWindows);
            outputStream = new FileOutputStream(configFile);
            configProps.storeToXML(outputStream, appName + " Setttings", "UTF-8");
            outputStream.close();
            Logger.getLogger(Finals.class.getName()).log(Level.INFO, "Properties are stored.");
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                outputStream.close();
            } catch (IOException ex) {
                Logger.getLogger(Finals.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

}
