/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package graph;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.graphstream.graph.*;
import org.graphstream.graph.implementations.*;
import org.graphstream.stream.file.FileSinkImages;
import org.graphstream.stream.file.FileSinkImages.LayoutPolicy;
import org.graphstream.stream.file.FileSinkImages.OutputPolicy;
import org.graphstream.stream.file.FileSinkImages.OutputType;
import org.graphstream.stream.file.FileSinkImages.Resolution;
import org.graphstream.stream.file.FileSinkImages.Resolutions;
import org.graphstream.stream.file.FileSourceDGS;

/**
 *
 * @author drosatosgr
 */
public class graphTesting {

//            public static void main(String args[]) {      
//                
//                Graph graph = new SingleGraph("Tutorial 1");
// 
//                graph.addNode("A");
//                graph.addNode("B");
//                graph.addNode("C");
//                graph.addNode("D");
//                graph.addEdge("AB", "A", "B");
//                graph.addEdge("BC", "B", "C");
//                graph.addEdge("CA", "C", "A");
//                graph.addEdge("DA", "D", "A");
//                graph.addEdge("DC", "D", "C");
// 
//                graph.display();               
//        }
            
                public static void main(String args[]) {
                    System.setProperty("gs.ui.renderer", "org.graphstream.ui.j2dviewer.J2DGraphRenderer");
        new graphTesting();
    }

    public graphTesting() {
        Graph graph = new SingleGraph("tutorial 1");

        //graph.addAttribute("ui.stylesheet", styleSheet);
        //graph.addEdge("4_4", "4", "4", true).addAttribute("layout.weight", 7.091967);
        
        graph.addAttribute("ui.stylesheet", "url('file:///"+(new File("files/graph.css")).getAbsolutePath()+"')");
        graph.addAttribute("ui.antialias");
        graph.setAutoCreate(true);
        graph.setStrict(false);
        
//        Viewer viewer = new Viewer(graph, Viewer.ThreadingModel.GRAPH_IN_ANOTHER_THREAD);
//// ...
//        View view = viewer.addDefaultView(false);   // false indicates "no JFrame".
//// ...
//        myJFrame.add(view);
        
        
        graph.display();

        graph.addEdge("AB", "A", "B");
        graph.addEdge("BC", "B", "C");
        graph.addEdge("CA", "C", "A");
        graph.addEdge("AD", "A", "D");
        graph.addEdge("DE", "D", "E");
        graph.addEdge("DF", "D", "F");
        graph.addEdge("EF", "E", "F");

        for (Node node : graph) {
            node.addAttribute("ui.label", node.getId());
        }

        explore(graph.getNode("A"),graph);
    }

    public void explore(Node source, Graph g) {
        Iterator<? extends Node> k = source.getBreadthFirstIterator();

        while (k.hasNext()) {
            Node next = k.next();
            g.addEdge(next.getId()+next.getId()+""+next.getId(), next.getId(), next.getId()+""+next.getId());
            
            sleep();
        }
    }

    protected void sleep() {
        try { Thread.sleep(5000); } catch (Exception e) {}
    }

    protected String styleSheet =
        "node {" +
        "   fill-color: black;" +
        "}" +
        "node.marked {" +
        "   fill-color: red;" +
        "}";
}
