/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lemur.dataStructures;

import sqlite.dataSources.Category;
import com.google.gson.JsonObject;
import java.io.Serializable;

/**
 *
 * @author drosatosgr
 */
public class CategoryScoreRank implements Serializable{
    
    private static final long serialVersionUID = -2225834518511397133L;
    
    public Integer _id;
    public String name;
    public String description;
    public Integer parent_id;
    public Integer rank;
    public Integer cutoff;
    public Double score;
    public Double scoreOfFirstInRank;
    
    public CategoryScoreRank(){
        _id = null;
        name = null;
        description = null;
        parent_id = null;
        rank = null;
        cutoff = null;
        score = null;
        scoreOfFirstInRank = null;
    }
    
    public CategoryScoreRank(Integer _id, String name, String description, Integer parent_id, Double score, Integer rank, Integer cutoff){
        this._id = _id;
        this.name = name;
        this.description = description;
        this.parent_id = parent_id;
        this.rank = rank;
        this.cutoff = cutoff;
        this.score = score;
        this.scoreOfFirstInRank = null;
    }
    
    public CategoryScoreRank(Category cat, Double score, Integer rank, Integer cutoff){
        this._id = cat._id;
        this.name = cat.name;
        this.description = cat.description;
        this.parent_id = cat.parent_id;
        this.rank = rank;
        this.cutoff = cutoff;
        this.score = score;
        this.scoreOfFirstInRank = null;
    }
    
    public CategoryScoreRank(Category cat, Double score, Double scoreOfFirstInRank, Integer rank, Integer cutoff){
        this._id = cat._id;
        this.name = cat.name;
        this.description = cat.description;
        this.parent_id = cat.parent_id;
        this.rank = rank;
        this.cutoff = cutoff;
        this.score = score;
        this.scoreOfFirstInRank = scoreOfFirstInRank;
    }
    
    public CategoryScoreRank(JsonObject ob){
        super();
        if(ob.get("_id") != null && !ob.get("_id").isJsonNull()) this._id = ob.get("_id").getAsInt();
        if(ob.get("name") != null && !ob.get("name").isJsonNull()) this.name = ob.get("name").getAsString();
        if(ob.get("description") != null && !ob.get("description").isJsonNull()) this.description = ob.get("description").getAsString();
        if(ob.get("parent_id") != null && !ob.get("parent_id").isJsonNull()) this.parent_id = ob.get("parent_id").getAsInt();
        if(ob.get("rank") != null && !ob.get("rank").isJsonNull()) this.rank = ob.get("rank").getAsInt();
        if(ob.get("cutoff") != null && !ob.get("cutoff").isJsonNull()) this.cutoff = ob.get("cutoff").getAsInt();
        if(ob.get("score") != null && !ob.get("score").isJsonNull()) this.score = ob.get("score").getAsDouble();
        if(ob.get("scoreOfFirstInRank") != null && !ob.get("scoreOfFirstInRank").isJsonNull()) this.scoreOfFirstInRank = ob.get("scoreOfFirstInRank").getAsDouble();
    }
    
    public JsonObject toJSON(){
        JsonObject ob = new JsonObject();
        ob.addProperty("_id", _id);
        ob.addProperty("name", name);
        ob.addProperty("description", description);
        ob.addProperty("parent_id", parent_id);
        ob.addProperty("score", score);
        ob.addProperty("scoreOfFirstInRank", scoreOfFirstInRank);
        ob.addProperty("rank", rank);
        ob.addProperty("cutoff", cutoff);
        return ob;
    }
    
    public String toJSONString(){
        return toJSON().toString();
    }
    
}
