/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lemur.dataStructures;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author drosatosgr
 */
public class DocumentOfIndex implements Serializable {

    private static final long serialVersionUID = -1115834518511397133L;

    public Integer indexID;
    public String docno;
    public String text;
    public ArrayList<CategoryScoreRank> Categs;

    public DocumentOfIndex() {
        this.indexID = null;
        this.docno = null;
        this.text = null;
        this.Categs = new ArrayList<CategoryScoreRank>();
    }

    public DocumentOfIndex(Integer indexid, String docno, String text) {
        this.indexID = indexid;
        this.docno = docno;
        this.text = text;
        this.Categs = new ArrayList<CategoryScoreRank>();
    }

    public void addCategory(CategoryScoreRank csr) {
        this.Categs.add(csr);
    }

    public JsonArray CategstoJSONArray() {
        JsonArray ob = new JsonArray();
        for (CategoryScoreRank csr : Categs) {
            ob.add(csr.toJSON());
        }
        return ob;
    }

    public String CategstoJSONArrayString() {
        return CategstoJSONArray().toString();
    }

    public String toTrecText() {
        String ret = "<DOC>\n";
        ret += "<DOCNO>" + this.docno + "</DOCNO>\n";
        ret += "<DOCAT>" + CategstoJSONArrayString() + "</DOCAT>\n";
        ret += "<TEXT>" + this.text + "\n</TEXT>\n</DOC>\n";
        return ret;
    }

    public Map getMetaData() {
        Map<String, String> hm = new HashMap<String, String>();
        hm.put("docno", this.docno);
        hm.put("docat", CategstoJSONArrayString());
        return hm;
    }

}
