/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sqlite;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import sqlite.MySQLiteHelper;
import sqlite.dataSources.Search;

/**
 *
 * @author drosatosgr
 */
public class SearchDataSource {

    MySQLiteHelper db;

    public SearchDataSource(MySQLiteHelper db) {
        this.db = db;
    }

    public boolean insertNewSearch(String JSONinString) {
        JsonParser parser = new JsonParser();
        return insertNewSearch(parser.parse(JSONinString).getAsJsonObject());
    }

    public boolean insertNewSearch(JsonObject job) {
        String sql = "INSERT INTO " + MySQLiteHelper.TABLE_SEARCH + " (" + MySQLiteHelper.SEARCH_COLUMN_QUERY + "," + MySQLiteHelper.SEARCH_COLUMN_ENGINE + "," + MySQLiteHelper.SEARCH_COLUMN_DATE + "," + MySQLiteHelper.SEARCH_COLUMN_BROWSER + ") VALUES (?, ?, ?, ?);";
        return db.insert(sql, new Object[]{job.get(MySQLiteHelper.SEARCH_COLUMN_QUERY).getAsString(), job.get(MySQLiteHelper.SEARCH_COLUMN_ENGINE).getAsString(), job.get(MySQLiteHelper.SEARCH_COLUMN_DATE).getAsLong(), job.get(MySQLiteHelper.SEARCH_COLUMN_BROWSER).getAsString()});
    }

    public ArrayList<Search> getUnCategorizedSearches() {
        ArrayList<Search> ret = new ArrayList<Search>();
        try {
            ResultSet rs = db.select("SELECT * FROM " + MySQLiteHelper.TABLE_SEARCH + " WHERE " + MySQLiteHelper.SEARCH_COLUMN_CATEGORISED + "=?;", new Object[]{0});
            if (rs != null) {
                while (rs.next()) {
                    ret.add(new Search(rs));
                }
                rs.close();
            }
        } catch (SQLException se) {
            Logger.getLogger(SearchDataSource.class.getName()).log(Level.SEVERE, null, se);
        }
        return ret;
    }
    
    public ArrayList<Object[]> getStatisticsOfSearches(Date from, Date to) {
        //SELECT engine, count(_id) FROM search where date between ? and ? and categorised != 0 group by engine;
        //SELECT browser, count(_id) FROM search where date between ? and ? and categorised != 0 group by browser;
        
        ArrayList<Object[]> ret = new ArrayList<Object[]>();
        int total = 0;
        int total2 = 0;
        try {
            while(true){
            ResultSet rs = db.select("SELECT "+MySQLiteHelper.SEARCH_COLUMN_ENGINE+", count(*) FROM " + MySQLiteHelper.TABLE_SEARCH + " WHERE " + MySQLiteHelper.SEARCH_COLUMN_DATE + " between ? AND ? AND "+MySQLiteHelper.SEARCH_COLUMN_CATEGORISED+" !=0 group by "+MySQLiteHelper.SEARCH_COLUMN_ENGINE+";", new Object[]{from,to});
            if (rs != null) {
                while (rs.next()) {
                    Object[] a = new Object[3];
                    a[0] = "Search Engine";
                    a[1] = rs.getString(1);
                    a[2] = rs.getInt(2);
                    total += rs.getInt(2);                
                    ret.add(a);
                }
                rs.close();
            }
            
            rs = db.select("SELECT "+MySQLiteHelper.SEARCH_COLUMN_BROWSER+", count(*) FROM " + MySQLiteHelper.TABLE_SEARCH + " WHERE " + MySQLiteHelper.SEARCH_COLUMN_DATE + " between ? AND ? AND "+MySQLiteHelper.SEARCH_COLUMN_CATEGORISED+" !=0 group by "+MySQLiteHelper.SEARCH_COLUMN_BROWSER+";", new Object[]{from,to});
            if (rs != null) {
                while (rs.next()) {
                    Object[] a = new Object[3];
                    a[0] = "Browser";
                    a[1] = rs.getString(1);
                    a[2] = rs.getInt(2);
                    total2 += rs.getInt(2);                
                    ret.add(a);
                }
                rs.close();
            }
            
            if(total == total2){
                    Object[] a = new Object[3];
                    a[0] = "Local Database";
                    a[1] = "Total Queries";
                    a[2] = total;               
                    ret.add(a);
                break;
            }else{
                ret = new ArrayList<Object[]>();
                total = 0;
                total2 = 0;
            }
            }
        } catch (SQLException se) {
            Logger.getLogger(SearchDataSource.class.getName()).log(Level.SEVERE, null, se);
        }
        return ret;
    }
    
    public void setSearchAsCategorized(Search s){
        db.update("UPDATE "+MySQLiteHelper.TABLE_SEARCH+" SET "+MySQLiteHelper.SEARCH_COLUMN_CATEGORISED+"=? Where "+MySQLiteHelper.SEARCH_COLUMN_ID+"=?;", new Object[]{s.categorized, s._id});
    }

}
