package webserver;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.Vector;

import com.sun.net.httpserver.Headers;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import finals.Finals;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import sqlite.MySQLiteHelper;
import sqlite.SearchDataSource;

public class WebServerHandler implements HttpHandler {
    
    SearchDataSource sds;

    public WebServerHandler(MySQLiteHelper db) {
        sds = new SearchDataSource(db);
    }

    public void handle(HttpExchange exchange) throws IOException {
        String requestMethod = exchange.getRequestMethod();

        if (requestMethod.equalsIgnoreCase("GET")) {
            Headers responseHeaders = exchange.getResponseHeaders();
            responseHeaders.set("Content-Type", "text/html");
            exchange.sendResponseHeaders(200, 0);

            OutputStream responseBody = exchange.getResponseBody();

            String response = "Welcome to "+Finals.appName;

            responseBody.write(response.getBytes());
            responseBody.close();

        } else if (requestMethod.equalsIgnoreCase("POST")) {
            InputStreamReader input = new InputStreamReader(exchange.getRequestBody(), "utf-8");
            BufferedReader reader = new BufferedReader(input);
            String line;
            String total = "";
            while ((line = reader.readLine()) != null) {
                if(total.equals("")){
                    total += line;
                }else{
                    total += "\n"+line;
                }
            }

            if(!sds.insertNewSearch(total)) Logger.getLogger(WebServerHandler.class.getName()).log(Level.WARNING, total);
            
            Headers responseHeaders = exchange.getResponseHeaders();
            responseHeaders.set("Content-Type", "text/html");
            exchange.sendResponseHeaders(200, 0);

            OutputStream responseBody = exchange.getResponseBody();

            String response = "Received";

            responseBody.write(response.getBytes());
            responseBody.close();  
        }
    }

}
